# Contribution Guidelines

## Introduction

This document explains how to contribute changes to the floating-labels project.
It assumes you have followed the
installation instructions on readme file.
Sensitive security-related issues should be reported to
[bug-reports@exactiweb.com](mailto:bug-reports@exactiweb.com) or on our website [exacti.com.br/contato](https://www.exacti.com.br/contato).


## Bug reports

Please search the issues on the issue tracker with a variety of keywords to ensure your bug is not already reported.

If unique, [open an issue](https://github.com/exacti/floating-labels/issues/new) and answer the questions so we can understand and reproduce the problematic behavior.

To show us that the issue you are having is in floating-labels itself, please write clear, concise instructions so we can reproduce the behavior, even if it seems obvious. The more detailed and specific you are, the faster we can fix the issue. Check out [How to Report Bugs Effectively](http://www.chiark.greenend.org.uk/~sgtatham/bugs.html) article.

Even though it is maintained by a company of Brazilian origin, the chosen language for issue reports is English.

Please be kind, remember that floating-labels  comes at no cost to you, and  you're getting free help.


## Code review

Changes to floating-labels must be reviewed before they are accepted, no matter who makes the change, even if they are an owner or a maintainer. We use GitHub's pull request workflow to do that. 

Please try to make your pull request easy to review for us. And, please read the *[How to get faster PR reviews](https://github.com/kubernetes/community/blob/261cb0fd089b64002c91e8eddceebf032462ccd6/contributors/guide/pull-requests.md#best-practices-for-faster-reviews)* guide. It has lots of useful tips for any project you may want to contribute.

Some of the key points:

* Make small pull requests. The smaller, the faster to review and the more likely it will be merged soon.
* Don't make changes unrelated to your PR. Maybe there are typos on some comments, maybe refactoring would be welcome on a function... but if that is not related to your PR, please make *another* PR for that.
* Split big pull requests into multiple small ones. An incremental change will be faster to review than a huge PR.


## Languages

All repository comunications work only with English language. 


## Add features

If you contribute with a new feature, few free to explain how to use in README.md file. This isn't required but we will take into consideration.

Please, describe better as you can the new feature in the pull request.

Changes on license file inst's allow (even  intentional).


## Versions

For now this project isn't maintained in versions, the last commit in master branch is the latest release.


## Copyright

Code that you contribute should use the standard copyright header:

```css
/**
 * Copyright (c) 2020. ExacTI Technology Solutions
 * MIT License.
 * https://exacti.com.br
 * floating-labels - https://github.com/exacti/floating-labels
 */
```
You also can add your GitHub profile link bellow the author line.

Files in the repository contain copyright from the year they are  added to the year they are last changed. If the copyright author is changed, just paste the header below the old one.